freeslot(
	"sfx_drop",
	"sfx_drop2",
	"sfx_bost",
	"sfx_bost2",
	"sfx_bost3",
	"sfx_peel",
	"sfx_chrg",
	"S_MBRING",
	"SPR_MBRG",
	"MT_MBRING"
)

mobjinfo[MT_MBRING] = {
	//doomednum = -1,
	spawnstate = S_MBRING,
	flags = MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_MBRING] = {
	sprite = SPR_MBRG,
	frame = TR_TRANS40|FF_PAPERSPRITE|A
}

local frac = FRACUNIT

local function SpawnRingEffect(p)
	local ring = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_MBRING)
	ring.angle = p.mo.angle + ANGLE_90
	ring.fuse = 7
	ring.scalespeed = frac/2
	ring.scale = 2*frac/3
	ring.destscale = 6*frac
	ring.color = p.mo.color
	ring.blendmode = AST_ADD
end


local function SpawnThokTrail(p)
	local trail = P_SpawnMobjFromMobj(p.mo, 0, 0, -7*frac, MT_THOK)
	trail.color = p.mo.color
	trail.scalespeed = frac/6
	trail.destscale = frac/10
	trail.fuse = 7
end

local function SpawnThokTrailAlt(p)
	local trailalt = P_SpawnMobjFromMobj(p.mo, 0, 0, -7*frac, MT_THOK)
	trailalt.color = p.mo.color
	trailalt.scalespeed = frac/6
	trailalt.destscale = frac/10
	trailalt.fuse = 7
	trailalt.blendmode = AST_ADD
end

local function SpawnThokTrailAlt2(p)
	local trailalt2 = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
	trailalt2.color = p.mo.color
	trailalt2.scale = frac/2
	trailalt2.scalespeed = frac/6
	trailalt2.destscale = frac*(5/4)
	trailalt2.fuse = 7
	trailalt2.blendmode = AST_ADD
end

local function SpawnGhostTrail(p)
	local ghost = P_SpawnGhostMobj(p.mo)
	ghost.z = p.mo.z
	ghost.fuse = 7
	ghost.scalespeed = frac
	ghost.scale = frac
	ghost.destscale = frac+frac/20
	ghost.color = p.mo.color
	ghost.blendmode = AST_ADD
	ghost.colorized = true
end

local function SpawnGhostTrail2(p)
	local ghost2 = P_SpawnGhostMobj(p.mo)
	ghost2.z = p.mo.z
	ghost2.fuse = 7
	ghost2.scalespeed = frac*2
	ghost2.scale = frac
	ghost2.destscale = frac+frac/3
	ghost2.color = p.mo.color
	ghost2.blendmode = AST_ADD
	ghost2.colorized = true
end

sfxinfo[sfx_drop].caption = "Dropdash"
sfxinfo[sfx_drop2].caption = "Dropdash Release"
sfxinfo[sfx_bost].caption = "Hyper Ring"
sfxinfo[sfx_bost2].caption = "Hyper Ring (Pitched Up)"
sfxinfo[sfx_bost3].caption = "Hyper Ring (Pitched Up)"
sfxinfo[sfx_chrg].caption = "Peelout Charge"
sfxinfo[sfx_peel].caption = "Peelout Release"

addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) then return end

		-- ALL BELOW ARE CHARACTER SPECIFIC ACTIONS --
		if p.mo.skin == "sonic"
			if not (p.cmd.buttons & BT_JUMP) then
				p.jumpready = true
				p.jump = false
			elseif p.jumpready then
				p.jump = true
				p.jumpready = false
			else
				p.jump = false
			end
			
			if not (p.pflags & PF_THOKKED)
			and (p.pflags & PF_JUMPED)
			and p.powers[pw_carry] == CR_NONE
			and not (p.cmd.buttons & BT_JUMP)
			and p.jump
				P_SetObjectMomZ(p.mo, p.speed/5 + 6*frac, false)
				P_InstaThrust(p.mo, p.mo.angle, p.actionspd + 4*frac + p.speed/5)
				S_StartSound(nil, sfx_thok, p)
				p.pflags = $1|PF_THOKKED
			end
			
			if p.dropdash == 1 -- plays the sound when you start a dropdash
				S_StartSound(nil, sfx_drop, p)
			end
			
			if p.dropdash > 1 -- spawns the trail
			and (p.pflags & PF_JUMPED)
			and p.playerstate ~= PST_DEAD
			and p.powers[pw_carry] == CR_NONE
				SpawnThokTrail(p)
			end
			
			if not P_IsObjectOnGround(p.mo) -- determines the power of the dropdash
			and (p.cmd.buttons & BT_USE)
			and (p.pflags & PF_JUMPED)
			and p.dropdash < 150
			and p.playerstate ~= PST_DEAD
			and p.powers[pw_carry] == CR_NONE
				p.dropdash = $ + 1
			elseif p.dropdash < 15
				p.dropdash = 0
			end
			
			if P_IsObjectOnGround(p.mo) -- actually makes you do the dropdash
			and p.dropdash > 1
			and (p.cmd.buttons & BT_USE)
			and p.playerstate ~= PST_DEAD
			and p.powers[pw_carry] == CR_NONE
				if p.powers[pw_super]
					P_StartQuake(45*frac, 2)
					P_NukeEnemies(p.mo, p.mo, 1000*frac)
					P_InstaThrust(p.mo, p.mo.angle, (p.dropdash*frac)/3+20*frac+p.speed)
				end
				P_InstaThrust(p.mo, p.mo.angle, (p.dropdash*frac)/3+10*frac+p.speed)
				S_StartSound(nil, sfx_drop2, p)
				p.dropdash = 0
				p.pflags = $1|PF_SPINNING
				p.mo.state = S_PLAY_ROLL
			end
			
			if P_IsObjectOnGround(p.mo)
				p.dropdash = 0
			end
			
			if p.pflags & PF_THOKKED -- if you thok, you spawn a trail
				SpawnThokTrailAlt(p)
			end
		end
		
		if p.mo.skin == "tails"
			if not (p.cmd.buttons & BT_JUMP) then
				p.jumpready = true
				p.jump = false
			elseif p.jumpready then
				p.jump = true
				p.jumpready = false
			else
				p.jump = false
			end
			
			if not (p.cmd.buttons & BT_CUSTOM2) then
				p.c2ready = true
				p.c2 = false
			elseif p.c2ready then
				p.c2 = true
				p.c2ready = false
			else
				p.c2 = false
			end
		
			/*if p.holdfly == 1 -- holdfly on
				if p.pflags & PF_THOKKED
				and not P_IsObjectOnGround(p.mo)
				and p.flighttime > 0
					if (p.cmd.buttons & BT_JUMP)
						p.mo.state = S_PLAY_FLY
						if p.mo.momz < 10*frac
							P_SetObjectMomZ(p.mo, frac+p.mo.momz, false)
							p.flighttime = $ - 1
						end
					elseif (p.cmd.buttons & BT_USE)
						P_SetObjectMomZ(p.mo, p.mo.momz-frac, false)
					end
					
					if (leveltime % 10 == 1)
					and p.mo.state == S_PLAY_FLY
						S_StartSound(nil, sfx_putput, p)
					end
					
					p.fly1 = 1
					p.pflags = $ & ~PF_JUMPED
				end
			elseif p.holdfly == 2 -- holdfly off
				if p.pflags & PF_THOKKED
				and not P_IsObjectOnGround(p.mo)
				and p.flighttime > 0
					if p.jump
						p.mo.state = S_PLAY_FLY
						if p.mo.momz < 10*frac
							P_SetObjectMomZ(p.mo, (3*frac)+p.mo.momz, false)
						end
					elseif (p.cmd.buttons & BT_USE)
						P_SetObjectMomZ(p.mo, p.mo.momz-frac, false)
					end
					
					if (leveltime % 10 == 1)
					and p.mo.state == S_PLAY_FLY
						S_StartSound(nil, sfx_putput, p)
					end
					
					p.flighttime = $ - 1
					p.fly1 = 1
					p.pflags = $ & ~PF_JUMPED
				end
			end*/
			
			if p.holdfly == 1 -- holdfly on
				if p.mo.state == S_PLAY_FLY or p.mo.state == S_PLAY_SWIM
					if (p.cmd.buttons & BT_JUMP)
						if p.mo.momz < 12*frac
							P_SetObjectMomZ(p.mo, frac+p.mo.momz, false)
						end
					end
					
					if (p.cmd.buttons & BT_USE)
						if p.mo.momz > -16*frac
							P_SetObjectMomZ(p.mo, p.mo.momz-(2*frac), false)
						end
					end
				end
			elseif p.holdfly == 2 -- holdfly off
				-- uhhhhhhhhh
			end
			
			/*if p.flighttime == 0 -- tired
			and not P_IsObjectOnGround(p.mo)
			and p.mo.state == S_PLAY_FLY
				p.mo.state = S_PLAY_FLY_TIRED
				if (leveltime % 10 == 1)
				and p.mo.state == S_PLAY_FLY_TIRED
					S_StartSound(nil, sfx_pudpud, p)
				end
			end*/
			
			/*if P_IsObjectOnGround(p.mo) -- resets flighttime and removes pf_thokked flag
				p.pflags = $ & ~PF_THOKKED
				p.flighttime = 150
				p.fly1 = 0
			end*/
			
			if p.c2 -- cancel flight
			and not P_IsObjectOnGround(p.mo)
			and (p.mo.state == S_PLAY_FLY or p.mo.state == S_PLAY_SWIM or p.mo.state == S_PLAY_FLY_TIRED)
				P_SetObjectMomZ(p.mo, 10*frac, false)
				S_StartSound(nil, sfx_drop, p)
				p.mo.state = S_PLAY_ROLL
				p.pflags = $1|PF_THOKKED|PF_JUMPED
			end
		end
		
		if p.mo.skin == "knuckles"
			if not (p.cmd.buttons & BT_CUSTOM1) then
				p.c1ready = true
				p.c1 = false
			elseif p.c1ready then
				p.c1 = true
				p.c1ready = false
			else
				p.c1 = false
			end
			
			if not (p.cmd.buttons & BT_CUSTOM2) then
				p.c2ready = true
				p.c2 = false
			elseif p.c2ready then
				p.c2 = true
				p.c2ready = false
			else
				p.c2 = false
			end
			
			if not P_IsObjectOnGround(p.mo) -- stomping
			and not p.stomp
			and p.c1
			and p.playerstate ~= PST_DEAD
				P_SetObjectMomZ(p.mo, -50*frac, false)
				S_StartSound(nil, sfx_zoom, p)
				p.mo.state = S_PLAY_FALL
				p.stomp = true
			end
			
			if p.c2 -- cancel glide
			and not P_IsObjectOnGround(p.mo)
			and (p.mo.state == S_PLAY_GLIDE or p.mo.state == S_PLAY_SWIM)
				P_SetObjectMomZ(p.mo, 10*frac, false)
				S_StartSound(nil, sfx_drop, p)
				p.mo.state = S_PLAY_ROLL
				p.pflags = $1|PF_THOKKED|PF_JUMPED
				p.pflags = $ & ~PF_GLIDING
			end
			
			if P_IsObjectOnGround(p.mo) -- stomped
			and p.stomp
			and p.playerstate ~= PST_DEAD
				P_StartQuake(35*frac, 2)
				P_NukeEnemies(p.mo, p.mo, 800*frac)
				S_StartSound(nil, sfx_s3k56, p)
				p.stomp = false
			end
			
			if p.stomp -- stomped on a spring
			and p.mo.state == S_PLAY_SPRING
				p.stomp = false
				P_SetObjectMomZ(p.mo, (10*frac)+p.mo.momz, false)
				S_StartSound(nil, sfx_sprong, p)
			end
		end
		-- ALL ABOVE ARE CHARACTER SPECIFIC ACTIONS --
		
		-- finally some global shit
		
		if p.fyromentum == 0 then return end -- if momentum is disabled then dont do nothin beyond this point
		
		p.hasnomomentum = true -- xmom support
		
		if p.pflags & PF_SPINNING 
		and not (p.pflags & PF_STARTDASH) 
		and P_IsObjectOnGround(p.mo) -- SINCE WHEN WAS IT THIS SIMPLE
			p.thrustfactor = (skins[p.mo.skin].thrustfactor)*20
		else
			p.thrustfactor = skins[p.mo.skin].thrustfactor
		end
		
		if not (skins[p.mo.skin].flags & SF_RUNONWATER)
			if p.speed > 50*frac
				p.charflags = $|SF_RUNONWATER
			else
				p.charflags = $ & ~SF_RUNONWATER
			end
		end
		
		-- momentum rework
		-- i had no idea a variable for friction existed
		if p.speed > 20*frac
			p.mo.friction = frac
		else
			p.mo.friction = frac-frac/15
		end
		
		//p.normalspeed = skins[p.mo.skin].normalspeed + (p.speed/2
		
		-- boost code
		if p.speed > 20*frac -- if the speed is above 20*frac
		or (p.pflags & PF_STARTDASH) -- or spindashing
			if p.Fboost < p.Fboostcap -- boost cap
				if (leveltime % 3 == 1)
					p.Fboost = $ + 1
				end
			end
		else -- if its below 20*frac
			if P_IsObjectOnGround(p.mo) -- and on ground
				p.Fboost = 0 -- go to 0 you dont deserve speed
			end
		end
		
		if P_PlayerInPain(p)
		or p.playerstate == PST_DEAD
			p.Fboost = 0
		end
		
		if p.Fboost < 0 -- if the boost falls below zero
			p.Fboost = 0 -- go to zero, so nothing breaks
		end
		
		if (leveltime % 3 == 1) -- so the sound doesnt play twice
			if p.Fboost == 25
			and p.Fboosting == 0
				p.boostfx = true
				p.Fboosting = 1
			end
			
			if p.Fboost == 50
			and p.Fboosting == 1
				p.boostfx2 = true
				p.Fboosting = 2
			end
			
			if p.Fboost == 100
			and p.Fboosting == 2
				p.boostfx3 = true
				p.Fboosting = 3
			end
		end
		
		if p.Fboost == 0
			p.Fboosting = 0
		end
		
		if not (skins[p.mo.skin].flags & SF_CANBUSTWALLS)
			if p.Fboosting >= 1
				p.charflags = $1|SF_CANBUSTWALLS
			else
				p.charflags = $ & ~SF_CANBUSTWALLS
			end
		end
		
		if p.Fboosting == 1
			p.normalspeed = skins[p.mo.skin].normalspeed * 5 / 4
			SpawnGhostTrail(p)
		end
		
		if p.Fboosting == 2
			p.normalspeed = skins[p.mo.skin].normalspeed * 3 / 2
			SpawnGhostTrail(p)
		end
		
		if p.Fboosting == 3
			p.normalspeed = skins[p.mo.skin].normalspeed * 12 / 5
			SpawnGhostTrail(p)
			SpawnGhostTrail2(p)
			SpawnThokTrailAlt2(p)
		end
		
		if p.Fboosting == 0
			p.normalspeed = skins[p.mo.skin].normalspeed
		end
		
		-- boost fx lvl 1
		if p.boostfx
			S_StartSound(nil, sfx_bost, p)
			S_StartSound(nil, sfx_zoom, p)
			p.boostfx = false
		end
		
		-- boost fx lvl 2
		if p.boostfx2
			S_StartSound(nil, sfx_bost2, p)
			S_StartSound(nil, sfx_zoom, p)
			p.boostfx2 = false
		end
		
		-- boost fx lvl 3
		if p.boostfx3
			S_StartSound(nil, sfx_bost3, p)
			S_StartSound(nil, sfx_peel, p)
			S_StartSound(nil, sfx_zoom, p)
			P_StartQuake(40*FRACUNIT, 3)
			SpawnRingEffect(p)
			p.boostfx3 = false
		end
		
		-- remove godmode
		if p.pflags & PF_GODMODE
			p.pflags = $ & ~PF_GODMODE
		end
		
		-- dash sprite for sonic
		if p.mo.skin == "sonic"
			if p.Fboosting >= 1
				if p.mo.state == S_PLAY_RUN
					p.mo.state = S_PLAY_DASH
				end
			else
				if p.mo.state == S_PLAY_DASH
					p.mo.state = S_PLAY_RUN
				end
			end
		end
		
		-- reroll
		if not (p.cmd.buttons & BT_USE) then
			p.useready = true
			p.use = false
		elseif p.useready then
			p.use = true
			p.useready = false
		else
			p.use = false
		end
		
		if not (p.cmd.buttons & BT_CUSTOM2) then
			p.c2ready = true
			p.c2 = false
		elseif p.c2ready then
			p.c2 = true
			p.c2ready = false
		else
			p.c2 = false
		end
		
		if not (p.charflags & SF_NOJUMPSPIN)
			if not P_IsObjectOnGround(p.mo)
			and not P_PlayerInPain(p)
			and not (p.pflags & PF_JUMPED)
			and not (p.pflags & PF_THOKKED)
			and not (p.pflags & PF_SPINNING)
			and p.playerstate ~= PST_DEAD
			and p.use
				p.pflags = $1|PF_JUMPED|PF_THOKKED
				p.mo.state = S_PLAY_ROLL
				S_StartSound(nil, sfx_zoom, p)
			end
			
			if P_IsObjectOnGround(p.mo)
			and (p.pflags & PF_SPINNING)
			and p.mo.state == S_PLAY_ROLL
			and p.c2
				p.pflags = $ & ~PF_SPINNING
				p.mo.state = S_PLAY_STND
				S_StartSound(nil, sfx_zoom, p)
			end
		end
	end
end)

addHook("AbilitySpecial", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) then return end
		
		if p.mo.skin == "sonic"
			if not (p.pflags & PF_THOKKED)
				P_SetObjectMomZ(p.mo, p.speed/5 + 8*frac, false)
				P_InstaThrust(p.mo, p.mo.angle, p.actionspd + 4*frac + p.speed/5)
				S_StartSound(nil, sfx_thok, p)
				p.pflags = $1|PF_THOKKED
			end
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if (p and p.mo and p.mo.valid)
		p.dropdash = 0
		p.flighttime = 150
		p.stomp = false
		p.boostsound = false
		p.Fboost = 0
		p.Fboosting = 0
		p.Fboostcap = 200
	end
end)

-- code base by cheeseboi
-- this all generates errors when the game is playing but it still works so who gives a fuck
addHook("TouchSpecial", function(mobj, playermobj)
    if playermobj.player.Fboosting >= 2 and mobj.flags & MF_ENEMY then
        P_KillMobj(mobj, playermobj, playermobj)
		playermobj.player.pflags = $1|PF_GODMODE
    end
end)

addHook("TouchSpecial", function(mobj, playermobj)
    if playermobj.player.Fboosting >= 2 and mobj.flags & MF_MONITOR then
        P_KillMobj(mobj, playermobj, playermobj)
		playermobj.player.pflags = $1|PF_GODMODE
    end
end)

addHook("TouchSpecial", function(mobj, playermobj)
    if playermobj.player.Fboosting >= 2 then
        P_KillMobj(mobj, playermobj, playermobj)
		playermobj.player.pflags = $1|PF_GODMODE
    end
end, MT_SPIKE)

addHook("TouchSpecial", function(mobj, playermobj)
    if playermobj.player.Fboosting >= 2 then
        P_KillMobj(mobj, playermobj, playermobj)
		playermobj.player.pflags = $1|PF_GODMODE
    end
end, MT_WALLSPIKE)